package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.CglEnum;
import de.uni_marburg.powersort.data.DataEnum;
import de.uni_marburg.powersort.sort.SortEnum;
import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Param;
import org.openjdk.jmh.annotations.Scope;
import org.openjdk.jmh.annotations.State;

/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public class JmhCgl extends JmhBase {
    @Param()
    CglEnum dataEnum;
    @Param()
    SortEnum sortEnum;

    @Override
    DataEnum getDataEnum(){
        return dataEnum;
    }
    @Override
    SortEnum getSortEnum(){
        return sortEnum;
    }

    // We could move this method up to JmhBase to avoid redundancy in the subclasses.
    // But this would remove the run button of the IntelliJ plugin "JMH Java Microbenchmark Harness".
    // Furthermore, with this approach we don't need to exclude JmhBase as it has no benchmark methods.
    @Benchmark
    public void benchmark() {
        sortImpl.sort(workingCopy);
    }
}
